﻿Type=Service
Version=5.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Private serial As Serial
	Private ast As AsyncStreamsText
	
End Sub

Sub Service_Create
	serial.Initialize("serial")
	serial.Connect(serial.GetPairedDevices.Get("HC-05"))
End Sub

Sub Serial_Connected (Success As Boolean)
	If Success Then
		ast.Initialize(me, "ast", serial.InputStream, serial.OutputStream)
	End If
	Log(Success)
End Sub

Sub ast_NewText(msg As String)
	CallSub2(Main, "MessageArrived", msg)
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub
