﻿Type=Service
Version=4.9
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region Module Attributes
	#StartAtBoot: False
#End Region

'Service module
Sub Process_Globals
End Sub
Sub Service_Create

End Sub

Sub Service_Start (StartingIntent As Intent)
	Select StartingIntent.Action
		Case "com.google.android.c2dm.intent.REGISTRATION"
			HandleRegistrationResult(StartingIntent)
		Case "com.google.android.c2dm.intent.RECEIVE"
			MessageArrived(StartingIntent)
	End Select
End Sub
Sub MessageArrived (Intent As Intent)
	Dim From, CollapseKey, Data As String 'ignore
	If Intent.HasExtra("from") Then From = Intent.GetExtra("from")
	If Intent.HasExtra("data") Then Data = Intent.GetExtra("data")
	If Intent.HasExtra("collapse_key") Then CollapseKey = Intent.GetExtra("collapse_key")
	Log(Intent.ExtrasToString)
	'Here you should handle the new message:
	Log("New message arrived: " & Data)
	ToastMessageShow("New message: " & Data, True)
	Dim n As Notification
	n.Initialize
	n.Icon = "icon"
	n.Sound = True
	n.SetInfo(Data, Data, Main)
	n.Notify(1)
End Sub


Sub RegisterDevice (Unregister As Boolean)
	Dim i As Intent
	If Unregister Then		
		i.Initialize("com.google.android.c2dm.intent.UNREGISTER", "")
	Else
		i.Initialize("com.google.android.c2dm.intent.REGISTER", "")
		i.PutExtra("sender", Main.SenderId)
	End If
	Dim jo As JavaObject = i
	jo.RunMethod("setPackage", Array("com.google.android.gms"))
	Dim r As Reflector
	Dim i2 As Intent
	i2 = r.CreateObject("android.content.Intent")
	Dim pi As Object
	pi = r.RunStaticMethod("android.app.PendingIntent", "getBroadcast", _
		Array As Object(r.GetContext, 0, i2, 0), _
		Array As String("android.content.Context", "java.lang.int", "android.content.Intent", "java.lang.int"))
	i.PutExtra("app", pi)
	StartService(i)
End Sub

Sub HandleRegistrationResult(Intent As Intent)
	If Intent.HasExtra("error") Then
		Log("Error: " & Intent.GetExtra("error"))
		ToastMessageShow("Error: " & Intent.GetExtra("error"), True)
	Else If Intent.HasExtra("registration_id") Then
		Dim token As String = Intent.GetExtra("registration_id")
		Dim j As HttpJob
		j.Initialize("j", Me)
		j.PostString(Main.ServerUrl & "/devicetoken", "token=" & token & "&type=2")
	End If
End Sub

Private Sub JobDone(j As HttpJob)
	If j.Success Then
		Log("Token uploaded successfully.")
	Else
		Log("Error uploading token")
	End If
	j.Release
End Sub



Sub Service_Destroy

End Sub
